var video = {
    cookieId: 'video_online',
    playerId: 'video_online',
    showVideo: true,
    isPlaying: false,
    checking: false,

    init: function() {
        var _self = this;

        var width = 0;
        var height = 0;

        if($('#' + this.playerId).length == 0) {
            var html = '<div id="' + this.playerId + '" style="display:none;"></div>';

            $('body').prepend(html);

            this.showVideo = false;
        } else {
            if($('#' + this.playerId).hasClass('video-inner')) {
                var url = $(location).attr('href');

                if(url.indexOf('?') != -1){
                    this.showVideo = false;
                    $('#online, .video-container, .announcements, .share').hide();
                }
            }
            
            if(this.showVideo) {
                width = $('#' + this.playerId).data('width');
                height = $('#' + this.playerId).data('height');

                if(!width)
                    width = 220;

                if(!height)
                    height = 193;

                $('.stream-selector').find('a').on('click', function(e){
                    e.preventDefault();

                    var parent = $(this).parents('li');

                    if(parent.hasClass('active'))
                        return;

                    $('.stream-selector').find('li, a').filter('.active').removeClass('active');

                    parent.addClass('active');
                    $(this).addClass('active');

                    _self.getPlayer().load([{file:$(this).data('stream')}]);
                });

                var h6_html = $('.stream-selector').find('h6').html();

                h6_html = $('.announcements').find('li').eq(0).find('div').filter('.title').text() + h6_html;

                $('.stream-selector').find('h6').html(h6_html);
            }
        }

        var bShow = $.cookie(this.cookieId);

        this.toggleHeader(!isUndefined(bShow) && bShow == 'true');

        var options = {
            flashplayer: '/js/player/player.swf',
            file: 'stream1',
            streamer: 'rtmp://193.232.254.49/live',
            /*file: 'http://content.bitsontherun.com/videos/lWMJeVvV-364767.mp4',*/
            autostart: 'true',
            events:{
                onPlay: function(){
                    var mute = (_self.showVideo) ? false : true;
                    _self.getPlayer().setMute(mute);
                    _self.onStart();
                },
                onReady: function(){
                    _self.isReady = true;
                    //console.log('onReady');
                    _self.autoCheck(true);
                },
                onIdle: function() {
                    //console.log('onIdle');
                    _self.autoCheck(true);
                    _self.onStop();
                }
            },
            width: width,
            height: height,
            wmode : 'transparent',
            image: '/img/video-null.jpg'
        }

        this.player = jwplayer(this.playerId).setup(options);
    },
    getPlayer: function() {
        return jwplayer(this.playerId);
    },
    autoCheck: function(bFirst) {
        var _self = this;

        if(this.checking)
            return;

        this.checking = true;

        time = (bFirst) ? 2 : 10;

        setTimeout(function() {
            _self.checkVideo();
            _self.checking = false;
            _self.autoCheck(false);
        }, time * 1000);
    },
    checkVideo: function() {
        var state = this.getPlayer().getState();

        if(state == 'PLAYING') {
            if(!this.isPlaying)
                this.onStart();
        } else if(state == 'IDLE' || state == 'BUFFERING') {
            if(this.isPlaying || this.isReady) {
                this.onStop();
            }
        }

        //console.log('checking - ' + state);
    },
    onStart: function() {
        this.isPlaying = true;

        if(this.showVideo) {
            $('.video-container').removeClass('video-null');
            $('#video-null').css('z-index', 1).hide();
            $('#trans').css('z-index', 2);
            $('.stream-selector').show();
            /*$('.stream-selector, .links').show();*/
        }

        $.cookie(this.cookieId, 'true');

        this.toggleHeader(true);
    },
    onStop: function() {
        //console.log('stopping');

        this.isPlaying = false;
        this.isReady = false;

        if(this.showVideo) {
            $('.video-container').addClass('video-null');
            $('#video-null').css('z-index', 2).show();
            $('#trans').css('z-index', 1);
            $('.stream-selector').hide();
            /*$('.stream-selector, .links').hide();*/
        }

        $.cookie(this.cookieId, 'false');

        this.toggleHeader(false);
    },
    toggleHeader: function(bShow) {
        if(bShow)
            $('.header-links').find('i').filter('.live').fadeIn();
        else
            $('.header-links').find('i').filter('.live').fadeOut();
    }
}